package com.sun.jmx.remote.util;

import sun.reflect.misc.ReflectUtil;

public class OrderClassLoaders extends ClassLoader
{
    private ClassLoader cl2;
    
    public OrderClassLoaders(ClassLoader parent, ClassLoader cl2) {
        super(parent);
        this.cl2 = cl2;
    }
    
    @Override
    protected Class<?> loadClass(String name, boolean resolve) throws ClassNotFoundException {
        ReflectUtil.checkPackageAccess(name);
        try {
            return super.loadClass(name, resolve);
        }
        catch (ClassNotFoundException ex) {
            if (this.cl2 != null) {
                return this.cl2.loadClass(name);
            }
            throw ex;
        }
    }
}
